import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:charts_flutter/flutter.dart' as charts;
import 'package:flutter/material.dart';

class ButtonView extends StatefulWidget {
  @override
  _ButtonViewState createState() => _ButtonViewState();
}

class _ButtonViewState extends State<ButtonView> {
  List<String> tag = ["#tag", "#insta", "#aagnia", "#live"];
  List<charts.Series> seriesList;
  bool animate;

  /// Create series list with multiple series
  static List<charts.Series<OrdinalSales, String>> _createSampleData() {
    final desktopSalesData = [
      new OrdinalSales('2014', 5),
      new OrdinalSales('2015', 25),
      new OrdinalSales('2016', 100),
      new OrdinalSales('2017', 75),
    ];

    final tableSalesData = [
      new OrdinalSales('2014', 25),
      new OrdinalSales('2015', 50),
      new OrdinalSales('2016', 10),
      new OrdinalSales('2017', 20),
    ];

    final mobileSalesData = [
      new OrdinalSales('2014', 10),
      new OrdinalSales('2015', 15),
      new OrdinalSales('2016', 50),
      new OrdinalSales('2017', 45),
    ];

    return [
      new charts.Series<OrdinalSales, String>(
        id: 'Desktop',
        domainFn: (OrdinalSales sales, _) => sales.year,
        measureFn: (OrdinalSales sales, _) => sales.sales,
        data: desktopSalesData,
      ),
      new charts.Series<OrdinalSales, String>(
        id: 'Tablet',
        domainFn: (OrdinalSales sales, _) => sales.year,
        measureFn: (OrdinalSales sales, _) => sales.sales,
        data: tableSalesData,
      ),
      new charts.Series<OrdinalSales, String>(
        id: 'Mobile',
        domainFn: (OrdinalSales sales, _) => sales.year,
        measureFn: (OrdinalSales sales, _) => sales.sales,
        data: mobileSalesData,
      ),
    ];
  }

  @override
  Widget build(BuildContext context) {
    /*return Scaffold(
      appBar: AppBar(
        backgroundColor: AppColors.APP_COLOR_PRIMARY,
        title: Text("Button Demo"),
      ),
      body: ListView(
        children: [
          GridView.count(
            crossAxisSpacing: 20,
            // Left and right spacing between Widget
            mainAxisSpacing: 10,
            //upper and lower spacing
            //padding: EdgeInsets.all(10),
            shrinkWrap: true,
            crossAxisCount: 2,
            children: [
               BUICard(
                cardSize: CardSize.large,
                cardType: CardType.customCard,
                cardColor: Colors.red,
                cardTextColor: Colors.white,
                cardText: "Test",
                height: 150,
                elevation: 30,
              ),
              BUICard(
                elevation: 10,
                cardColor: Colors.black,
                cardText: "Testing",
                height: 70,
                cardTextColor: Colors.white,
                cardSize: CardSize.medium,
                cardType: CardType.customCard,
              ),
              BUICard.titleCard(
                cardSize: CardSize.small,
                cardType: CardType.cardWithTitle,
                cardColor: Colors.red,
                cardTextColor: Colors.white,
                cardText: "Content",
                cardName: "Main Content",
                cardTitle: "Title",
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.circular(15.0),
                ),
                //height: 120,
                elevation: 10,
              ),
              BUICard.titleCard(
                cardSize: CardSize.medium,
                cardType: CardType.cardWithTitle,
                cardColor: Colors.blue,
                cardTextColor: Colors.white,
                cardText: "Content",
                cardName: "Main Content",
                cardTitle: "Title",
                //height: 120,
                elevation: 10,
              ),
              BUICard.titleCard(
                cardSize: CardSize.large,
                cardType: CardType.cardWithTitle,
                cardColor: Colors.blue,
                cardTextColor: Colors.white,
                cardText: "Content",
                cardName: "Main Content",
                cardTitle: "Title",
                //height: 120,
                elevation: 10,
              ),
              BUICard.titleCard(
                // cardSize: CardSize.small,
                cardType: CardType.cardWithTitle,
                cardColor: Colors.blue,
                cardTextColor: Colors.white,
                cardText: "Content",
                cardName: "Main Content",
                cardTitle: "Title",
                height: 110,
                elevation: 10,
              ),
              BUICard.dashBoardCardDeals(
                cardType: CardType.cardDashBoardDeal,
                width: MediaQuery.of(context).size.width * 0.5,
                height: 150,
                padding: 10,
                trandValue: true,
              ),
              BUICard.dashBoardCardDeals(
                cardType: CardType.cardDashBoardDeal,
                width: MediaQuery.of(context).size.width,
                height: 150,
                padding: 10,
                trandValue: false,
              ),
              BUICard.dashBoardCardDeals(
                cardType: CardType.cardDashBoardDeal,
                width: MediaQuery.of(context).size.width,
                height: 150,
                padding: 10,
                trandValue: true,
              ),
              BUICard.dashBoardCardDeals(
                cardType: CardType.cardDashBoardDeal,
                width: MediaQuery.of(context).size.width,
                height: 150,
                padding: 10,
                trandValue: false,
              ),
            ],
          ),
        ],
      ),
    );*/
    return Scaffold(
        body: Padding(
          padding: const EdgeInsets.all(8.0),
          child: Column(children: [
            Expanded(
              child: GridView.count(
                crossAxisCount: countValue,
                childAspectRatio: (aspectWidth / aspectHeight),
                children: gridItems
                    .map((data) => GestureDetector(
                          onTap: () {
                            getGridViewSelectedItem(context, data);
                          },
                          child: BUICard.dashBoardCardDeals(
                            cardType: CardType.cardDashBoardDeal,
                            width: MediaQuery.of(context).size.width * 0.2,
                            padding: 1,
                            cardSize: CardSize.large,
                            trandValue: true,
                          ),
                          /*              child: Container(
                          margin: EdgeInsets.symmetric(vertical: 5, horizontal: 5),
                          color: Colors.lightBlueAccent,
                          child: Center(
                              child: Text(data,
                                  style:
                                      TextStyle(fontSize: 22, color: Colors.white),
                                  textAlign: TextAlign.center)))*/
                        ))
                    .toList(),
              ),
            ),
            Container(
                margin: const EdgeInsets.fromLTRB(30, 10, 10, 10),
                child: RaisedButton(
                  onPressed: () => changeMode(),
                  child: Text(' Change GridView Mode To ListView '),
                  textColor: Colors.white,
                  color: Colors.red,
                  padding: EdgeInsets.fromLTRB(12, 12, 12, 12),
                ))
          ]),
        ),
    );
  }

  num countValue = 2;

  num aspectWidth = 2;

  num aspectHeight = 1;

  List<String> gridItems = [
    'One',
    'Two',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
  ];

  changeMode() {
    if (countValue == 2) {
      setState(() {
        countValue = 1;
        aspectWidth = 3;
        aspectHeight = 1;
      });
    } else {
      setState(() {
        countValue = 2;
        aspectWidth = 2;
        aspectHeight = 1;
      });
    }
  }

  getGridViewSelectedItem(BuildContext context, String gridItem) {
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: new Text(gridItem),
          actions: <Widget>[
            FlatButton(
              child: new Text("OK"),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
          ],
        );
      },
    );
  }
}

class OrdinalSales {
  final String year;
  final int sales;

  OrdinalSales(this.year, this.sales);
}
